function [f] = ilift_db2(A,D)
db2 = liftwave('db2');

% (5) normalization
A = A * db2{4,2};
D = D * db2{4,1};

% (4) the second predict
for k=2:length(D)
    D(k) = D(k) - db2{3,2} * A(k-1);
end
D(1) = D(1);% + db2{3,2} * A(end);

% (3) the first update
for k=1:length(A)-1
    A(k) = A(k) - db2{2,2}(2) * D(k) - db2{2,2}(1) * D(k+1);
end
A(end) = A(end) - db2{2,2}(2) * D(end);% + db2{2,2}(1) * D(1);

% (2) the first predict
for k=1:length(D)
    D(k) = D(k) - db2{1,2} * A(k);
end

% (1) merge
f(1:2:2*length(A)) = A(:);
f(2:2:2*length(D)) = D(:);

end